#include <bits/stdc++.h>

#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
typedef long long ll;

using namespace std;


const int dd = (int)5e4 + 7;
vector<vector<int> > E;
vector<int> used, ans;
vector<int> T;

int in[dd][4], out[dd][4];

void topsort(int v) {
    used[v] = 1;
    for (int to : E[v]) if (!used[to])
        topsort(to);
    T.push_back(v);
}

struct edge {
    int a, b, ind;
};

void go(int l, int r, vector<edge> &edges) {

    if (l == r) return;
    int m = (l + r) / 2;

    vector<edge> A, B;

    for (auto c : edges) {
        if (c.a <= m && c.b <= m) A.push_back(c);
        else if (c.a > m && c.b > m) B.push_back(c);
        else {

            int ind = -1;
            int mn = (int)1e9;
            for (int col = 0; col < 3; col++) {

                int cur = in[c.a][col] + 1 + out[c.b][col];
                if (cur < mn) {
                    mn = cur;
                    ind = col;
                }
            }

            ans[c.ind] = ind;
            in[c.b][ind] = max(in[c.b][ind], in[c.a][ind] + 1);
            out[c.a][ind] = max(out[c.a][ind], out[c.b][ind] + 1);

        }
    }

    go(l, m, A);
    go(m + 1, r, B);

}

void solve() {
    int n, m;
    cin >> n >> m;

    E.resize(n);
    ans.resize(m);

    vector<edge> edges;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        E[a - 1].push_back(b - 1);
        edges.push_back({ a - 1, b - 1, i });
    }

    used.assign(n, 0);
    for (int i = 0; i < n; i++) if (!used[i])
        topsort(i);

    reverse(T.begin(), T.end());
    go(0, (int)T.size() - 1, edges);

    for (int x : ans) {
        if (x == 0) cout << "R\n";
        else if (x == 1) cout << "G\n";
        else cout << "B\n";
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < 3; j++) {
            err("in[%d][%d] = %d\n", i, j, in[i][j]);
            err("out[%d][%d] = %d\n", i, j, out[i][j]);
        }
    }*/
}

int main() {
#ifdef SIR
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}