#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <stack>

using namespace std;

#define forn(i, n) for(int i = 0; i < (n); ++i)

void dfs (const vector<vector<int>> &gr, vector<bool> &used, vector<int> &ord, int v)
{
    if (used[v])
        return;

    used[v] = true;

    for (auto it : gr[v])
        dfs (gr, used, ord, it);

    ord.push_back (v);
}


void solve (istream &cin = std::cin, ostream &cout = std::cout)
{
    int n, m;

    cin >> n >> m;

    vector<vector<int>> gr (n);

    vector<pair<int, int>> edges (m);

    for (int i = 0; i < m; i++)
    {
        int a, b;

        cin >> a >> b;
        a--;
        b--;

        gr[a].push_back (b);
        edges[i] = { a, b };
    }

    vector<int> ord;
    vector<bool> used (n);

    for (int i = 0; i < gr.size (); i++)
        dfs (gr, used, ord, i);

    reverse (ord.begin (), ord.end ());

    vector<int> num (ord.size ());

    for (int i = 0; i < num.size (); i++)
        num[ord[i]] = i;

    for (auto it : edges)
    {
        vector<int> la, lb;

        for (int i = 0; i < 3; i++)
        {
            la.push_back (it.first % 42);
            it.first /= 42;
        }
        for (int i = 0; i < 3; i++)
        {
            lb.push_back (it.second % 42);
            it.second /= 42;
        }

        string rgb = "RGB";

        for (int j = 2; j >= 0; j--)
        {
            if (la[j] != lb[j])
            {
                cout << rgb[j] << endl;

                break;
            }
        }
    }
}

int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);

    cout << fixed << setprecision (20);

#ifdef LOCAL
    solve ();

    cout << setprecision (4);
    cout << "clock: " << clock () / (double)CLOCKS_PER_SEC << endl;
#else
    solve ();
#endif

    return 0;
}
