#include <iostream>
#include <algorithm>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <random>

using namespace std;
mt19937 gen(time(NULL));
const int N = 200500, M = 200500;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define forn(i, n) for (int i = 0; i < n; i++)

int path_right[N];
int path_left[N];

int best_keyboard_naive(vector<int> fst, vector<int> snd) {
	vector<int> priority(101);
	int n = fst.size();
	if (n == 1) return fst[0];
	for (int i = 0; i < n; i++) {
		priority[fst[i]] = i;
	}

	int br = fst.back();
	for (auto i : fst) {
		vector<int> nfst, nsnd;
		for (auto elem : fst) if (elem != i) nfst.push_back(elem);
		for (auto elem : snd) if (elem != i) nsnd.push_back(elem);
		int abr = best_keyboard_naive(nsnd, nfst);
		if (priority[abr] < priority[br]) br = abr;
	}

	return br;
}

int best_keyboard(vector<int> fst, vector<int> snd) {
	bool change = true;
	while (change) {
		change = false;
		vector<int> cnt(101);
		int n = fst.size();
		if (n <= 9) {
			return best_keyboard_naive(fst, snd);
		}
		for (int i = 0; i < n - 1; i++) {
			if (i % 2 == 0) cnt[fst[n - 1 - i / 2]]++;
			else cnt[snd[n - 1 - i / 2]]++;
		}
		vector<int> nfst, nsnd;
		for (auto elem : fst) {
			if (cnt[elem] == 2) change = true;
			else nfst.push_back(elem);
		}
		for (auto elem : snd) {
			if (cnt[elem] == 2) change = true;
			else nsnd.push_back(elem);
		}
		fst = nfst;
		snd = nsnd;
	}

	vector<int> cnt(101);
	int n = fst.size();
	if (n <= 9) return best_keyboard_naive(fst, snd);
	for (int i = 0; i < n - 1; i++) {
		if (i % 2 == 0) cnt[fst[n - 1 - i / 2]]++;
		else cnt[snd[n - 1 - i / 2]]++;
	}
	for (auto elem : fst) {
		if (cnt[elem] == 0) return elem;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;

	cin >> n;

	vector<int> key_1(n), key_2(n);
	for (int i = 0; i < n; i++) cin >> key_1[i];
	for (int i = 0; i < n; i++) cin >> key_2[i];

	int res = best_keyboard(key_1, key_2);

	vector<int> winning_turns;
	for (int i = 1; i <= n; i++) {
		vector<int> nk1, nk2;
		for (auto elem : key_1) if (elem != i) nk1.push_back(elem);
		for (auto elem : key_2) if (elem != i) nk2.push_back(elem);
		if (res == best_keyboard(nk2, nk1)) winning_turns.push_back(i);
	}

	cout << res << endl;
	cout << winning_turns.size() << endl;
	for (auto elem : winning_turns) cout << elem << ' ';
	cout << endl;

	return 0;
}
