#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5;
const int INF = 1e9 + 9;

struct Query {
    int x, y, num;
    Query(int x = -1, int y = -1, int num = -1):
        x(x), y(y), num(num) {}
};

bool cmp(const Query &a, const Query &b) {
    if (a.x == b.x)
        return a.y < b.y;
    return a.x > b.x;
}

int h[MAXN];
long long res[MAXN];

struct Seg {
    int x, y, h;
    Seg(int x = 0, int y = 0, int h = 0):
        x(x), y(y), h(h) {}
};

deque <Seg> k;
deque <long long> suf_sum;
int n;

void solve(vector <Query> &v) {
    sort(v.begin(), v.end(), cmp);
    k.clear();
    suf_sum.clear();
    k.push_back(Seg(n, n, INF));
    suf_sum.push_back(0);

    int last = 0;
    for (int i = n - 2; i >= 0; i--) {
        while (k.front().h <= h[i]) {
            k.pop_front();
            suf_sum.pop_front();
        }
        k.push_front(Seg(i + 1, k[0].x - 1, h[i]));
        suf_sum.push_front(suf_sum[0] + (long long)k[0].h * (k[0].y - k[0].x + 1));

        while (last < (int)v.size() && v[last].x == i) {
            int b = v[last].y;
            int l = 0, r = (int)k.size();
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (k[m].x <= b)
                    l = m;
                else
                    r = m;
            }

            res[v[last].num] = suf_sum[0] - suf_sum[l + 1];

            last++;
        }
    }
}

vector <Query> v1, v2;

int main() {
    //freopen("in.in", "r", stdin);

    ios_base::sync_with_stdio(false);

    cin >> n;
    for (int i = 0; i < n - 1; i++)
        cin >> h[i];

    int m; cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--, b--;
        if (a > b)
            v1.push_back(Query(b, a, i));
        else
            v2.push_back(Query(n - 1 - b, n - 1 - a, i));
    }

    solve(v1);

    for (int i = 0; n - i - 2 > i; i++)
        swap(h[i], h[n - i - 2]);
    solve(v2);

    for (int i = 0; i < m; i++)
        cout << res[i] << endl;

    return 0;
}
