#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)

using namespace std;

const int N = 4000;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const int P = 787;

namespace sol1
{

ll pw1[N + 1], pw2[N + 1];
ll h1[N + 1], h2[N + 1];

void init(string s)
{
    int n = sz(s);
    pw1[0] = pw2[0] = 1;
    h1[0] = h2[0] = 0;
    rep(i, 1, n + 1)
    {
        pw1[i] = pw1[i - 1] * P % MOD;
        pw2[i] = pw2[i - 1] * P % MOD1;

        h1[i] = (h1[i - 1] * P + s[i - 1]) % MOD;
        h2[i] = (h2[i - 1] * P + s[i - 1]) % MOD1;
    }
}

ll get_hash(int l, int r)
{
    ll r1 = h1[r] - h1[l] * pw1[r - l] % MOD;
    if (r1 < 0) r1 += MOD;
    ll r2 = h2[r] - h2[l] * pw2[r - l] % MOD1;
    if (r2 < 0) r2 += MOD1;

    return r1 * MOD1 + r2;
}

int p;
ll a[N * N * 3];

int get_cnt(int n)
{
    p = 0;
    rep(i, 0, n)
        rep(j, i, n)
            a[p++] = get_hash(i, j + 1);
    sort(a, a + p);
    return (unique(a, a + p) - a);
}

ll solve(string s, int n)
{
    int len = sz(s);
    string t;
    while (sz(t) < n)
        t += s;
    t = t.substr(0, n);
    init(t);
    return get_cnt(n);
}

}

namespace sol2
{

ll pw1[N + 1], pw2[N + 1];
ll h1[N + 1], h2[N + 1];

void init(string s)
{
    int n = sz(s);
    pw1[0] = pw2[0] = 1;
    h1[0] = h2[0] = 0;
    rep(i, 1, n + 1)
    {
        pw1[i] = pw1[i - 1] * P % MOD;
        pw2[i] = pw2[i - 1] * P % MOD1;

        h1[i] = (h1[i - 1] * P + s[i - 1]) % MOD;
        h2[i] = (h2[i - 1] * P + s[i - 1]) % MOD1;
    }
}

ll get_hash(int l, int r)
{
    ll r1 = h1[r] - h1[l] * pw1[r - l] % MOD;
    if (r1 < 0) r1 += MOD;
    ll r2 = h2[r] - h2[l] * pw2[r - l] % MOD1;
    if (r2 < 0) r2 += MOD1;

    return r1 * MOD1 + r2;
}

int p;
ll a[N * N * 3];
int p1;
ll b[N * N * 3];

int get_cnt(int n)
{
    p = 0;
    rep(i, 0, n)
        rep(j, i, n)
            a[p++] = get_hash(i, j + 1);
    sort(a, a + p);
    return (unique(a, a + p) - a);
}

int get_cnt(int n, int m)
{
    p = 0;
    rep(i, 0, n)
        rep(j, n * 2, n * 2 + m)
            a[p++] = get_hash(i, j + 1);
    sort(a, a + p);
    return (unique(a, a + p) - a);
}

string getPeriod(string s)
{
    int n = sz(s);
    rep(d, 1, n + 1)
        if (n % d == 0)
        {
            string t;
            rep(i, 0, n / d)
                t += s.substr(0, d);
            if (t == s)
                return s.substr(0, d);
        }
}

ll solve(string s, int n)
{
    s = getPeriod(s);
    //cout << s << endl;

    int len = sz(s);
    init(s + s + s);
    if (n <= len * 2)
        return get_cnt(n);

    ll ans = get_cnt(len + len);
    ans += (ll)(n / len - 2) * get_cnt(len, len);

    //cout << get_cnt(len, n % len) << endl;

    if (n % len != 0)
        ans += get_cnt(len, n % len);
    return ans;
}

}

string getRandString(int len)
{
    string res;
    rep(i, 0, len)
        res += char('a' + rand() % 2);
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;

    string s;
    int n;
    cin >> s >> n;
    cout << sol2::solve(s, n) << "\n";
    return 0;

    /*freopen("a.in", "r", stdin);

    if (true)
    {
        string s; int n;
        cin >> s >> n;

        ll r1 = sol1::solve(s, n);
        ll r2 = sol2::solve(s, n);

        cout << r1 << " " << r2 << endl;
        return 0;
    }*/

    int T = 10000;
    for (int t = 1; t <= T; t++)
    {
        cout << "Test " << t << endl;
        int n = rand() % 1000 + 1;
        int len = rand() % 100 + 1;
        n = max(n, len);
        string s = getRandString(len);

        ll r1 = sol1::solve(s, n);
        ll r2 = sol2::solve(s, n);

        if (r1 != r2)
        {
            cout << s << "\n" << n << "\n";
            cout << r1 << " " << r2 << "\n";
            break;
        }
    }
    return 0;
}
